<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01//EN" "http://www.w3.org/TR/html4/strict.dtd">

<html lang="en">
<head>

<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">

<meta name="generator" content="PHPDoctor 2RC4 (http://peej.github.com/phpdoctor/)">
<meta name="when" content="Fri, 15 Apr 2011 16:43:07 +0000">

<link rel="stylesheet" type="text/css" href="../../stylesheet.css">
<link rel="start" href="../../overview-summary.html">

<title>classes/programElementDoc.php (PHPDoctor)</title>

</head>
<body id="file" onload="parent.document.title=document.title;">

<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/programelementdoc.php.html" target="_top">No frames</a>
</div>
<hr>

<h1>classes/programElementDoc.php</h1>
<hr>

<a name="line1"></a><pre><?php
<a name="line2"></a>/*
<a name="line3"></a>PHPDoctor: The PHP Documentation Creator
<a name="line4"></a>Copyright (C) 2004 Paul James <paul@peej.co.uk>
<a name="line5"></a>
<a name="line6"></a>This program is free software; you can redistribute it and/or modify
<a name="line7"></a>it under the terms of the GNU General Public License as published by
<a name="line8"></a>the Free Software Foundation; either version 2 of the License, or
<a name="line9"></a>(at your option) any later version.
<a name="line10"></a>
<a name="line11"></a>This program is distributed in the hope that it will be useful,
<a name="line12"></a>but WITHOUT ANY WARRANTY; without even the implied warranty of
<a name="line13"></a>MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
<a name="line14"></a>GNU General Public License for more details.
<a name="line15"></a>
<a name="line16"></a>You should have received a copy of the GNU General Public License
<a name="line17"></a>along with this program; if not, write to the Free Software
<a name="line18"></a>Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
<a name="line19"></a>*/
<a name="line20"></a>
<a name="line21"></a>/** Represents a PHP program element: global, function, class, interface,
<a name="line22"></a> * field, constructor, or method. This is an abstract class dealing with
<a name="line23"></a> * information common to these elements.
<a name="line24"></a> *
<a name="line25"></a> * @package PHPDoctor
<a name="line26"></a> * @abstract
<a name="line27"></a> */
<a name="line28"></a>class ProgramElementDoc extends Doc
<a name="line29"></a>{
<a name="line30"></a>
<a name="line31"></a>	/** Reference to the elements parent.
<a name="line32"></a>	 *
<a name="line33"></a>	 * @var doc
<a name="line34"></a>	 */
<a name="line35"></a>	var $_parent = NULL;
<a name="line36"></a>
<a name="line37"></a>	/** The elements package.
<a name="line38"></a>	 *
<a name="line39"></a>	 * @var str
<a name="line40"></a>	 */
<a name="line41"></a>	var $_package = NULL;
<a name="line42"></a>
<a name="line43"></a>	/** If this element is final.
<a name="line44"></a>	 *
<a name="line45"></a>	 * @var bool
<a name="line46"></a>	 */
<a name="line47"></a>	var $_final = FALSE;
<a name="line48"></a>
<a name="line49"></a>	/** Access type for this element.
<a name="line50"></a>	 *
<a name="line51"></a>	 * @var str
<a name="line52"></a>	 */
<a name="line53"></a>	var $_access = 'public';
<a name="line54"></a>
<a name="line55"></a>	/** If this element is static.
<a name="line56"></a>	 *
<a name="line57"></a>	 * @var bool
<a name="line58"></a>	 */
<a name="line59"></a>	var $_static = FALSE;
<a name="line60"></a>	
<a name="line61"></a>	/** Which source file is this element in
<a name="line62"></a>	 *
<a name="line63"></a>	 * @var str
<a name="line64"></a>	 */
<a name="line65"></a>	var $_filename = NULL;
<a name="line66"></a>	
<a name="line67"></a>	/** The line in the source file this element can be found at
<a name="line68"></a>	 *
<a name="line69"></a>	 * @var int
<a name="line70"></a>	 */
<a name="line71"></a>	var $_lineNumber = NULL;
<a name="line72"></a>	
<a name="line73"></a>	/** The source path containing the source file
<a name="line74"></a>	 *
<a name="line75"></a>	 * @var str
<a name="line76"></a>	 */
<a name="line77"></a>	var $_sourcePath = NULL;
<a name="line78"></a>	
<a name="line79"></a>	/** Set element to have public access */
<a name="line80"></a>	function makePublic()
<a name="line81"></a>    {
<a name="line82"></a>		$this->_access = 'public';
<a name="line83"></a>	}
<a name="line84"></a>
<a name="line85"></a>	/** Set element to have protected access */
<a name="line86"></a>	function makeProtected()
<a name="line87"></a>    {
<a name="line88"></a>		$this->_access = 'protected';
<a name="line89"></a>	}
<a name="line90"></a>
<a name="line91"></a>	/** Set element to have private access */
<a name="line92"></a>	function makePrivate()
<a name="line93"></a>    {
<a name="line94"></a>		$this->_access = 'private';
<a name="line95"></a>	}
<a name="line96"></a>
<a name="line97"></a>	/** Get the containing class of this program element. If the element is in
<a name="line98"></a>	 * the global scope and does not have a parent class, this will return null.
<a name="line99"></a>	 *
<a name="line100"></a>	 * @return ClassDoc
<a name="line101"></a>	 */
<a name="line102"></a>	function &containingClass()
<a name="line103"></a>    {
<a name="line104"></a>        $return = NULL;
<a name="line105"></a>        if (strtolower(get_class($this->_parent)) == 'classdoc') {
<a name="line106"></a>            $return =& $this->_parent;
<a name="line107"></a>        }
<a name="line108"></a>        return $return;
<a name="line109"></a>	}
<a name="line110"></a>
<a name="line111"></a>	/** Get the package that this program element is contained in.
<a name="line112"></a>	 *
<a name="line113"></a>	 * @return PackageDoc
<a name="line114"></a>	 */
<a name="line115"></a>	function &containingPackage()
<a name="line116"></a>    {
<a name="line117"></a>		return $this->_root->packageNamed($this->_package);
<a name="line118"></a>	}
<a name="line119"></a>	
<a name="line120"></a>	/** Get the name of the package that this program element is contained in.
<a name="line121"></a>	 *
<a name="line122"></a>	 * @return str
<a name="line123"></a>	 */
<a name="line124"></a>	function packageName()
<a name="line125"></a>    {
<a name="line126"></a>		return $this->_package;
<a name="line127"></a>	}
<a name="line128"></a>
<a name="line129"></a>	/** Get the fully qualified name.
<a name="line130"></a>	 *
<a name="line131"></a>	 * <pre>Example:
<a name="line132"></a>for the method bar() in class Foo in the package Baz, return:
<a name="line133"></a>	Baz\Foo\bar()</pre>
<a name="line134"></a>	 *
<a name="line135"></a>	 * @return str
<a name="line136"></a>	 */
<a name="line137"></a>	function qualifiedName()
<a name="line138"></a>    {
<a name="line139"></a>		$parent =& $this->containingClass();
<a name="line140"></a>		if ($parent && $parent->name() != '' && $this->_package != $parent->name()) {
<a name="line141"></a>			return $this->_package.'\\'.$parent->name().'\\'.$this->_name;
<a name="line142"></a>		} else {
<a name="line143"></a>			return $this->_package.'\\'.$this->_name;
<a name="line144"></a>		}
<a name="line145"></a>	}
<a name="line146"></a>
<a name="line147"></a>	/** Get modifiers string.
<a name="line148"></a>	 *
<a name="line149"></a>	 * <pre> Example, for:
<a name="line150"></a>	public abstract int foo() { ... }
<a name="line151"></a>modifiers() would return:
<a name="line152"></a>	'public abstract'</pre>
<a name="line153"></a>	 *
<a name="line154"></a>	 * @return str
<a name="line155"></a>	 */
<a name="line156"></a>	function modifiers($showPublic = TRUE)
<a name="line157"></a>    {
<a name="line158"></a>		$modifiers = '';
<a name="line159"></a>		if ($showPublic || $this->_access != 'public') {
<a name="line160"></a>			$modifiers .= $this->_access.' ';
<a name="line161"></a>		}
<a name="line162"></a>		if ($this->_final) {
<a name="line163"></a>			$modifiers .= 'final ';
<a name="line164"></a>		}
<a name="line165"></a>		if (isset($this->_abstract) && $this->_abstract) {
<a name="line166"></a>			$modifiers .= 'abstract ';
<a name="line167"></a>		}
<a name="line168"></a>		if ($this->_static) {
<a name="line169"></a>			$modifiers .= 'static ';
<a name="line170"></a>		}
<a name="line171"></a>		return $modifiers;
<a name="line172"></a>	}
<a name="line173"></a>
<a name="line174"></a>	/** Return true if this program element is public.
<a name="line175"></a>	 *
<a name="line176"></a>	 * @return bool
<a name="line177"></a>	 */	
<a name="line178"></a>	function isPublic()
<a name="line179"></a>    {
<a name="line180"></a>		if ($this->_access == 'public') {
<a name="line181"></a>			return TRUE;
<a name="line182"></a>		} else {
<a name="line183"></a>			return FALSE;
<a name="line184"></a>		}
<a name="line185"></a>	}
<a name="line186"></a>
<a name="line187"></a>	/** Return true if this program element is protected.
<a name="line188"></a>	 *
<a name="line189"></a>	 * @return bool
<a name="line190"></a>	 */	
<a name="line191"></a>	function isProtected()
<a name="line192"></a>    {
<a name="line193"></a>		if ($this->_access == 'protected') {
<a name="line194"></a>			return TRUE;
<a name="line195"></a>		} else {
<a name="line196"></a>			return FALSE;
<a name="line197"></a>		}
<a name="line198"></a>	}
<a name="line199"></a>
<a name="line200"></a>	/** Return true if this program element is private.
<a name="line201"></a>	 *
<a name="line202"></a>	 * @return bool
<a name="line203"></a>	 */	
<a name="line204"></a>	function isPrivate()
<a name="line205"></a>    {
<a name="line206"></a>		if ($this->_access == 'private') {
<a name="line207"></a>			return TRUE;
<a name="line208"></a>		} else {
<a name="line209"></a>			return FALSE;
<a name="line210"></a>		}
<a name="line211"></a>	}
<a name="line212"></a>	
<a name="line213"></a>	/** Return true if this program element is final.
<a name="line214"></a>	 *
<a name="line215"></a>	 * @return bool
<a name="line216"></a>	 */	
<a name="line217"></a>	function isFinal()
<a name="line218"></a>    {
<a name="line219"></a>		return $this->_final;
<a name="line220"></a>	}
<a name="line221"></a>	
<a name="line222"></a>	/** Return true if this program element is static.
<a name="line223"></a>	 *
<a name="line224"></a>	 * @return bool
<a name="line225"></a>	 */	
<a name="line226"></a>	function isStatic()
<a name="line227"></a>    {
<a name="line228"></a>		return $this->_static;
<a name="line229"></a>	}
<a name="line230"></a>	
<a name="line231"></a>	/** Get the source location of this element
<a name="line232"></a>	 *
<a name="line233"></a>	 * @return str
<a name="line234"></a>	 */
<a name="line235"></a>	function location()
<a name="line236"></a>	{
<a name="line237"></a>		return $this->sourceFilename().' at line '.$this->sourceLine();
<a name="line238"></a>	}
<a name="line239"></a>	
<a name="line240"></a>	function sourceFilename()
<a name="line241"></a>	{
<a name="line242"></a>		$phpdoctor = $this->_root->phpdoctor();
<a name="line243"></a>	    return substr($this->_filename, strlen($this->_sourcePath) + 1);
<a name="line244"></a>	}
<a name="line245"></a>	
<a name="line246"></a>	function sourceLine()
<a name="line247"></a>	{
<a name="line248"></a>	    return $this->_lineNumber;
<a name="line249"></a>	}
<a name="line250"></a>    
<a name="line251"></a>	/** Return the element path.
<a name="line252"></a>	 *
<a name="line253"></a>	 * @return str
<a name="line254"></a>	 */
<a name="line255"></a>	function asPath()
<a name="line256"></a>    {
<a name="line257"></a>		if ($this->isClass() || $this->isInterface() || $this->isException()) {
<a name="line258"></a>			return strtolower(str_replace('.', '/', str_replace('\\', '/', $this->_package)).'/'.$this->_name.'.html');
<a name="line259"></a>		} elseif ($this->isField()) {
<a name="line260"></a>			$class =& $this->containingClass();
<a name="line261"></a>			if ($class) {
<a name="line262"></a>				return strtolower(str_replace('.', '/', str_replace('\\', '/', $this->_package)).'/'.$class->name().'.html#').$this->_name;
<a name="line263"></a>			} else {
<a name="line264"></a>				return strtolower(str_replace('.', '/', str_replace('\\', '/', $this->_package)).'/package-globals.html#').$this->_name;
<a name="line265"></a>			}
<a name="line266"></a>		} elseif ($this->isConstructor() || $this->isMethod()) {
<a name="line267"></a>			$class =& $this->containingClass();
<a name="line268"></a>			if ($class) {
<a name="line269"></a>				return strtolower(str_replace('.', '/', str_replace('\\', '/', $this->_package)).'/'.$class->name().'.html#').$this->_name.'()';
<a name="line270"></a>			} else {
<a name="line271"></a>				return strtolower(str_replace('.', '/', str_replace('\\', '/', $this->_package)).'/package-functions.html#').$this->_name.'()';
<a name="line272"></a>			}
<a name="line273"></a>		} elseif ($this->isGlobal()) {
<a name="line274"></a>			return strtolower(str_replace('.', '/', str_replace('\\', '/', $this->_package)).'/package-globals.html#').$this->_name;
<a name="line275"></a>		} elseif ($this->isFunction()) {
<a name="line276"></a>			return strtolower(str_replace('.', '/', str_replace('\\', '/', $this->_package)).'/package-functions.html#').$this->_name.'()';
<a name="line277"></a>		}
<a name="line278"></a>		return NULL;
<a name="line279"></a>	}
<a name="line280"></a>
<a name="line281"></a>}
<a name="line282"></a>
<a name="line283"></a>?>
<a name="line284"></a></pre>
<div class="header">
<h1>PHPDoctor</h1>
<ul>
<li><a href="../../overview-summary.html">Overview</a></li>
<li>Package</li><li>Class</li><li>Tree</li><li><a href="../../overview-files.html">Files</a></li>
<li><a href="../../deprecated-list.html">Deprecated</a></li>
<li><a href="../../todo-list.html">Todo</a></li>
<li><a href="../../index-all.html">Index</a></li>
</ul>
</div>

<div class="small_links">
<a href="../../index.html" target="_top">Frames</a>
<a href="../../source/classes/programelementdoc.php.html" target="_top">No frames</a>
</div>
<hr>

<p id="footer">This document was generated by <a href="http://peej.github.com/phpdoctor/">PHPDoctor: The PHP Documentation Creator</a></p>

</body>

</html>